From 44daee7db0e6cc32f67ad2e944e7e68d73d3acc4 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Arsen=20Arsenovi=C4=87?= <arsen@aarsen.me>
Date: Sun, 20 Nov 2022 22:23:33 +0100
Subject: [PATCH] build_target: Fix possible out-of-bounds edge case

Detected on Tinderbox with FORTIFY_SOURCE=3.

Bug: https://bugs.gentoo.org/882295
---
 src/functions/kernel/build_target.c | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

diff --git a/src/functions/kernel/build_target.c b/src/functions/kernel/build_target.c
index 07b20e29..2ecc27c4 100644
--- a/src/functions/kernel/build_target.c
+++ b/src/functions/kernel/build_target.c
@@ -307,7 +307,6 @@ determine_target_build_name(struct workspace *wk, struct obj_build_target *tgt,
 	obj name_pre, obj name_suff, char plain_name[BUF_SIZE_2k])
 {
 	const char *pref, *suff, *ver_suff = NULL;
-	uint32_t i;
 
 	switch (tgt->type) {
 	case tgt_executable:
@@ -341,10 +340,7 @@ determine_target_build_name(struct workspace *wk, struct obj_build_target *tgt,
 		suff = get_cstr(wk, name_suff);
 	}
 
-	i = snprintf(plain_name, BUF_SIZE_2k, "%s%s", pref, get_cstr(wk, tgt->name));
-	if (suff) {
-		snprintf(&plain_name[i], BUF_SIZE_2k, ".%s", suff);
-	}
+	snprintf(plain_name, BUF_SIZE_2k, "%s%s%s%s", pref, get_cstr(wk, tgt->name), suff ? "." : "", suff ? suff : "");
 
 	tgt->build_name = make_strf(wk, "%s%s%s", plain_name, ver_suff ? "." : "", ver_suff ? ver_suff : "");
 	return true;
-- 
2.34.5

